From 5095e60f7dd2235db50323a4d6ca12d0113e4740 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Apr 28 2016 08:16:35 +0000
Subject: [PATCH 460/1001] Add the logic add a widget to a hub


---

diff --git a/hubs/app.py b/hubs/app.py
index 5f5f3b6..b5d3453 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -11,6 +11,7 @@ import six
 from flask.ext.openid import OpenID
 
 import hubs.models
+import hubs.widgets
 
 import datanommer.models
 
@@ -131,6 +132,7 @@ def hub_edit_get(name):
     return flask.render_template(
         'hubs.html', hub=hub, session=session, edit=True)
 
+
 def hub_edit_post(name):
     hub = get_hub(session, name)
     is_js = flask.request.form.get('js', False)
@@ -193,6 +195,106 @@ def hub_edit_post(name):
         return flask.redirect(flask.url_for('hub', name=name))
 
 
+@app.route('/<name>/add/', methods=['GET', 'POST'])
+@app.route('/<name>/add', methods=['GET', 'POST'])
+def hub_add_widgets(name):
+    if flask.request.method == 'POST':
+        return hub_add_widget_post(name)
+    else:
+        return hub_add_widget_get(name)
+
+
+@app.route('/<name>/add/<widget_name>/', methods=['GET'])
+@app.route('/<name>/add/<widget_name>', methods=['GET'])
+def hub_add_widget(name, widget_name):
+    hub = get_hub(session, name)
+    side = str(flask.request.args.get('position')).lower()
+    if side not in ['right', 'left']:
+        flask.abort(400, 'Invalid position provided')
+
+    widget = None
+    w_name = None
+    for widgt in hubs.widgets.registry:
+        if hubs.widgets.registry[widgt].position in ['both', side] \
+                and widgt == widget_name:
+            w_name = widgt
+            widget = hubs.widgets.registry[widgt]
+
+    return flask.render_template(
+        'add_widget.html',
+        hub=hub,
+        widget=widget,
+        widget_name=w_name,
+        side=side,
+        url_to=flask.url_for('hub_add_widgets', name=name),
+    )
+
+
+def hub_add_widget_get(name):
+    hub = get_hub(session, name)
+    side = str(flask.request.args.get('position')).lower()
+    if side not in ['right', 'left']:
+        flask.abort(400, 'Invalid position provided')
+
+    widgets = [
+        widget
+        for widget in hubs.widgets.registry
+        if hubs.widgets.registry[widget].position in ['both', side]
+    ]
+    return flask.render_template(
+        'add_widget.html',
+        hub=hub,
+        widgets=widgets,
+        side=side,
+    )
+
+
+def hub_add_widget_post(name):
+    print flask.request.form
+    widget_name = flask.request.form.get('widget_name')
+    position = flask.request.form.get('position', '').lower()
+    if not widget_name:
+        flask.abort(400, 'Invalid request sent')
+    if widget_name not in hubs.widgets.registry:
+        flask.abort(404, 'Unknown widget called')
+
+    hub = get_hub(session, name)
+
+    widget = widget = hubs.models.Widget(
+        plugin=widget_name, index=-1, left=position=='left')
+    error = False
+    config = {}
+    for arg in widget.module.data.widget_arguments:
+        val = flask.request.form.get(arg.name)
+        if not val:
+            flask.flash(
+                'You must provide a value for: %s' % arg.name, 'error')
+            error = True
+            break
+        try:
+            arg.validator(session, val)
+            config[arg.name] = val
+        except Exception as err:
+            flask.flash('Invalid data provided, error: %s' % err, 'error')
+            error = True
+    if not error:
+        widget.hub = hub
+        widget.config = config
+        try:
+            session.add(widget)
+            session.flush()
+            widget.hub.last_edited = datetime.datetime.utcnow()
+            session.commit()
+        except Exception as err:
+            print err
+            flask.flash(
+                'Could not save the configuration to the database '\
+                'if the error persists, please warn an admin',
+                'error')
+
+    return flask.render_template(
+        'hubs.html', hub=hub, session=session, edit=True)
+
 
 @app.route('/<hub>/<idx>/')
 @app.route('/<hub>/<idx>')
